function editor.traceEditorHelp( )

	-- trace("")

	if animationPanel.open  then return end

	trace("Entities: "..#selectedEntities.."/"..#room.entities.."        ".."State: "..editState)

	if not helpEnabled then return end

	if not level.isAnim then 
		trace("hold middle mouse or hit tab to wasdqe walk")
		trace("alt + middle mouse to orbit")
		if editor.debug.trace_info then 
			trace()
		end
	end

	trace("")
	trace("space+drag     - pan")
	trace("cmd return     - play")
	trace("cmd shft enter - play from default cam")
	trace("escape         - resume editing")
	trace("cmd escape     - exit editor")
	trace("cmd +/=/0      - zoom in/out/reset")
	trace("scroll(+shift) - zoom/track in/out")
	trace("cmd scroll     - change lens")
	trace("alt +/=/0      - resolution up/down/reset")
	trace("cmd A          - select all")
	trace("cmd S          - save")
	trace("esc / return   - exit / enter room")
	trace("c 1-9.         - reset camera")
	trace("shift c 1-9    - set camera")
	trace("cmd O          - toggle ortho")
	trace("v 1-9.         - reset viewport")
	trace("shift v 1-9    - set viewport")
	trace("R              - reset transform")
	trace("cmd P          - prerender")
	--trace("cmd T          - toggle tracking")
	--trace("cmd O          - toggle ortho")
	trace("cmd G          - toggle grid")
	trace("cmd L          - toggle lines")
	--trace("cmd I          - toggle level info")
	--trace("cmd 9          - reset cam to 0,0")
	trace("cmd R          - reload source")
	trace("cmd(+shift) Z  - undo(redo)")
	trace("shift+click    - select multiple")
	trace("click/right click stuff")
	trace(" +hold cmd to bypass warnings")
	if pathsPanel.open then trace("hit N for new path point") end

	trace("")
end

function editor.traceAnimationHelp(panel)
	
	if not helpEnabled then return end

	if not level.isAnim then
		trace("cmd return  - save and exit to level")
		trace("cmd esc     - exit without saving") 
		trace("tilde       - toggle anim mode")
		trace("")
	end

	if panel.l.type=="drawing" then 
		trace("Drawing:")
		trace(" B           - brush tool")
		trace(" P/X         - pen tool")
		trace(" E           - eraser")
		trace(" D           - toggle draw")
		trace(" F           - fill bucket tool")
		trace(" L           - lasso select")
		trace(" V           - move/transform tool")
		trace("      shift (while scaling) - lock ratio")
		trace("      alt   (while scaling) - lock side(s)")
		trace(" [ / ]       - change brush/pen size")
		trace(" G           - color picker")
		trace(" alt         - color eyedrop")
		trace(" space       - pan")
		trace(" shift+space - zoom")
		trace(" cmd +/=/0   - zoom in/out/reset")
		trace(" delete      - delete frame")
		trace(" backspace   - clear frame contents")
		trace("   + shift        + clear transform")
		trace("   + cmd     - delete frame")
		trace("   + alt     - delete frame inline")
		trace(" Z,X,C       - rough, line, note")
		trace("   + shift   - convert to")
		-- trace(" cmd P     - prune frame")
		-- trace(" cmd J     - toggle frame bounds")
	else
		trace(" M      - toggle mesh edit")
		trace("cmd W      - toggle wireframe")
	end

	trace("")

	if panel.l.remodel then 
		trace("-Mesh Editing:(")
		trace(" 1/2/3    - selection type")
		trace(" 4        - toggle see through")
		trace(" 5        - togle orbit mode")
		trace(" 6        - togle render mode")
			trace("")
		trace(" cmd A    - (de)select all")
		trace(" alt A  	 - invert selection")
		trace(" L        - lasso select")
		trace(" C        - circle select")
			trace("")
		trace(" R        - rotate")
		trace(" S        - scale")
		trace(" G        - grab/move")
		trace("   -> (shift)X/Y/Z to lock (plane)axis")
		trace("   		+ shift to lock plane")
			trace("")
		trace(" F        - flatten")
		trace(" D        - dissolve")
		trace(" I        - inset")
		trace(" K        - knife")
		trace(" T        - triangulate")
		trace(" M        - merge")
		trace(" E        - extrude")
		trace(" alt E    - extrude along normals")
		trace(" shift E  - extrude individual faces")
			trace("")
		trace("  while RSG-ing")
		trace("      scroll to change proportional")
		trace("      editing falloff")
			trace("")
		trace("cmd c       - copy geometry")
		trace("cmd v       - paste geometry")
	else 
		trace("Timeline:")
		trace(" Q           - new blank frame")
		trace(" shift Q     - duplicate frame")
		trace(" K           - mark key")
		trace(" S           - split frame")
		trace(" 1 / 2       - prev/next frame")
		trace(" shift 1 / 2 - prev/next key")
		trace(" 3 / 4       - move frame")
		trace(" shift 3 / 4 - shorten/extend frame")
		trace(" 5           - toggle solo layer")
		trace(" up / down   - change layers")
		trace(" left/right  - step fwd/back")
		trace("     + shift - scrub frames")
		trace(" O           - toggle onion skin")
		trace(" , / .       - toggle onion sides")
		trace("     + shift - toggle onion types")
		trace(" tap space   - play/pause")
		trace(" cmd return  - play from start")
		trace(" esc         - stop on current frame")
		trace(" cmd N       - new layer of current type")
		trace("") 

		trace("Other:")
		trace(" cmd S       - save animation")
		trace(" cmd E       - export cut")
		trace(" cmd shift E - export animation")
		trace(" cmd X,C,V   - cut,copy,paste contents")
		trace("     + shift - cut,copy,paste frame(s)")
		trace(" cmd R       - reset transform")
		trace(" cmd T       - toggle tween")
		trace(" cmd B       - toggle full timeline")
		trace(" cmd(shift)Z - undo(redo) "..tostring((panel.undoPos or 1).."/"..mc(1,#panel.undos,animationPanel.maxUndos).." [max "..animationPanel.maxUndos.."]"))
		trace("")

		trace("Tips:")
		trace(" right click the top of the timeline")
		trace("   - quick scrub bar")
		trace(" drag the bottom of the timeline")
		trace("   - pan timeline")

	end


	--trace("     +alt   - paste inline")
	-- trace("        click and drag inbetween ")
	-- trace("        tweened frames to ease")

	--trace("cmd B       - toggle background")
	trace(" cmd shift []- flip between anims")
	trace(" click name  - switch/add/rename anims")
	trace(" drag n drop audio or images to add")
	if panel.animation.source then 
		trace(" click audio name to mute")
	end
	trace(" try right clicking stuff for more options")
	

	trace("")
	
end